import type { BuildType, ObjectBasedSelectiveOption, ObjectSelectiveOptions, SelectiveSkipBuildType, SelectiveType } from '../types/bundlib-options';
import type { TypeCheckFunction } from '../types/helper-types';
export declare type SelectiveResolved<K extends string, T> = Record<K, T>;
export declare const API_BUILD_KEYS: ['main', 'module', 'browser'];
export declare const MODULE_BUILD_KEYS: ["main", "module", "browser", "bin"];
export declare const ALL_BUILD_KEYS: ["main", "module", "browser", "bin", "types"];
export declare function populateWithAPIValue<T>(value: T, result: SelectiveResolved<string, T>): SelectiveResolved<string, T>;
export declare function resolveObjectSelectiveOption<K extends BuildType, T, D>(value: ObjectSelectiveOptions<SelectiveType<K>, T>, defaultValue: D, isValidValue: TypeCheckFunction<T>, isBuildType: TypeCheckFunction<K>, allKeys: K[], invalid: TypeError): SelectiveResolved<K, T | D>;
export declare function resolveObjectSelectiveOption<K extends SelectiveSkipBuildType, T, D>(value: ObjectSelectiveOptions<SelectiveType<K>, T>, defaultValue: D, isValidValue: TypeCheckFunction<T>, isBuildType: TypeCheckFunction<K>, allKeys: K[], invalid: TypeError): SelectiveResolved<K, T | D>;
export declare function resolveObjectSelectiveOption<K extends string, T, D>(value: ObjectSelectiveOptions<SelectiveType<K>, T>, defaultValue: D, isValidValue: TypeCheckFunction<T>, isBuildType: TypeCheckFunction<K>, allKeys: K[], invalid: TypeError): SelectiveResolved<K, T | D>;
export declare function resolveObjectBasedSelectiveOption<T, D>(value: ObjectBasedSelectiveOption<BuildType, T>, defaultValue: D, isValidValue: TypeCheckFunction<T>, allKeys: BuildType[], optionName: string, urlHash?: string): SelectiveResolved<BuildType, T | D>;
