import type { IsExternal, OutputOptions as RollupOutputOptions, Plugin, RollupOptions, WarningHandlerWithDefault, WatcherOptions as RollupWatcherOptions } from 'rollup';
import type { Dictionary } from './helper-types';
export declare type RollupSourcemapString = 'inline' | 'hidden';
export declare type RollupSourcemap = boolean | RollupSourcemapString;
export declare type ModuleBuildFormat = 'cjs' | 'es';
export declare type BrowserBuildFormat = 'iife' | 'amd' | 'umd';
export declare type BundlibBuildFormat = ModuleBuildFormat | BrowserBuildFormat;
export interface BundlibRollupModuleOutputOptions extends RollupOutputOptions {
    file: string;
    format: BundlibBuildFormat;
    sourcemap: RollupSourcemap;
    esModule: boolean;
    interop: boolean;
}
export interface BundlibRollupBrowseOutputOptions extends BundlibRollupModuleOutputOptions {
    name: string;
    extend: boolean;
    globals: Dictionary<string>;
    amd?: {
        id: string;
    };
}
export interface BundlibRollupOptions<OutputOptions extends BundlibRollupModuleOutputOptions> extends RollupOptions {
    input: string;
    output: OutputOptions;
    external: IsExternal;
    plugins: Plugin[];
    watch: RollupWatcherOptions;
}
export interface BundlibAPIOptions {
    dev?: boolean;
    watch?: boolean;
    onwarn?: WarningHandlerWithDefault;
}
